// 1. Разница между обьявлением переменных через var, let и const.

//Несколько основных деталей:
//(*) Переменная, обьявленная var, существует и способна "всплывать" вверх до объявления и равна undefined.Переменные типа
//let & const не существуют до объявленияи, при обращении к ним до обьявления, вызывают ошибку. Это упрощает диагностику багов кода(причина 1).

//(**) Переменные обьявленные через let могут существовать в пределах блока кода {ограниченного фигурными скобками}, это дает
//возможность работать с ними локально. Переменная, обьявленная var, видна повсеместно в рамках данного кода(причина 2).

//(***) Циклы еще не проходили, но на сейчас понятно, что переменные, заданные внутри цикла с помощью var, выносят свои значения за рамки цикла.
//Переменные обьявленные через let внутри цикла, работают только внутри цикла, далее ни на что не влияют. Это, думаю, подобно описанной выше Причине 2.

// Переменные обьяленные через const допускают только одно присвоение значения, в отличии от let, где переназначать значение можно сколько угодно.
//Используется для обьявление переменных, значение которых мы не хотим менять и закрываем такую возможность осознанно. Это и есть разница с let.

// 2. Почему объявлять переменную через var считается плохим тоном?

//Потому что, используя let и const кодировщик делает комфортным использование написанного им кода другим членам команды.

//2.1. Как правило, код пишут коллективно. И кто как назовет свои переменные заранее не понятно. let & const не снимают проблему, но немного
//нивелируют Проблему 2. Кроме этого, приходится работать с чужим кодом. Избегание var облегчает поиск и определение причин ошибок (Причина 1)
//
//2.2. Разумеется, возникают ограничения, с учетом специфика let & const. Но, считается,что такой подход заставляет писать вдумчиво,
// придерживаясь практики "ответственного кода".


let usName = prompt('Your name?');
if (!isNaN(usName) || !usName || +usName === 0) {
    usName = prompt(`Enter Your name (previously: ${usName}) again, please!`, usName);
}
if (+usName === 0 ) {
    usName = 'No-name visitor';
}
let ageNat = prompt('Your age?');
let age = +ageNat;
if (isNaN(age) || age === 0) {
    age = +prompt(`Dear ${usName}, enter Your age (previously: ${ageNat}) again, please!`, age);
}
if (age < 18 || isNaN(age)) {
    alert('You are not allowed to visit this website!');
} else if (age > 22) {
    alert(`Welcome, ${usName}!`);
} else {
    if (confirm('Are you sure you want to continue?')) {
        alert(`Welcome, ${usName}!`);
    } else {
       alert('You are not allowed to visit this website!'); 
    }
}